unit graficos;
{---------------------------------------------}
{------------Parte que se exporta-------------}
{---------------------------------------------}
interface
{------------------}
{----Constantes----}
{------------------}
const NumMalos     = 5;                  { Se definen como constantes}
      NumTraidores = 2;                  {para facilitar posibles    }
      TableroX     = 150;                {cambios                    }
      TableroY     = 100;
      vacia        = False;
      llena        = True;
      FactorEscala = 4;
      AnchoBordes  = 2;
{-------------------}
{--Tipos definidos--}
{-------------------}
type casillas = record
                estado   : boolean;  {El estado de la casilla, llena o
vacia}
                peligro  : boolean;  {Si se est  haciendo un area o no}
                rellenar : boolean;  {Si se debe rellenar cuando}
                end;                 {se cierre el area o no    }

     malo = object
          x, y, incx, incy : integer;   {La posicin y la direccin}
          prohibida : boolean;          {Casillas por donde no se puede
mover}
          procedure
Fijar(posx,posy:byte;incrx,incry:shortint;prohi:boolean);
          procedure Mover;
     end;

     traidor = object (malo)       {Para mayor claridad}
     end;
{-------------}
{--Variables--}
{-------------}
var tablero : array [1..TableroX, 1..TableroY] of casillas;
    malos : array[1..NumMalos] of malo;
    traidores : array[1..NumTraidores] of traidor;
    nivel, PosBuenoX, PosBuenoY : integer;
    tecla                       : char;

{--------------------------------------------}
{--Inicializacion y cierre del modo gr fico--}
{--------------------------------------------}
procedure ModoGrafico;
procedure Modotexto;

{---------------------------------------}
{--Presentacin y escritura de rtulos--}
{---------------------------------------}
procedure EscribeTexto(posx,posy,tamno:integer;texto:string);
procedure RotuloXONIX;
procedure RotuloVidas(vidas:byte);
procedure RotuloArea(area:integer);
procedure RotuloPuntos(puntos:integer);
procedure RotuloNivel(nivel:byte);
procedure AvisoVidas(vidas:byte);
procedure AvisoNivel(nivel:byte);

{---------------------------}
{--Procedures de los malos--}
{---------------------------}
procedure PintarMalo;
procedure PintarTraidor;

{-------------------------------------------------}
{--Procedures que dibujan en la pantalla gr fica--}
{-------------------------------------------------}
procedure Rellenar;
procedure LimpiarTablero;
procedure PintarBueno(dirx,diry:shortint);
procedure HacerArea(x,y:integer);
procedure Rellenado;

{-------------------------------------------------}
{------------------Parte oculta-------------------}
{-------------------------------------------------}
implementation
uses graph;

{--------------------------------------------}
{--Inicializacion y cierre del modo gr fico--}
{--------------------------------------------}
procedure ModoGrafico;
{Inicializa el modo gr fico}
   var controlador, modo : integer;
   begin
        controlador := vga;
        modo := vgahi;
        InitGraph(controlador,modo,' ');
        if Graphresult = grOK then exit
          else begin
            writeln('No se ha encontrado el fichero de gr ficos');
            readln;
            halt
           end;
   end;

procedure ModoTexto;
{Cierra el modo gr fico}
   begin
        Closegraph
   end;

{---------------------------------------}
{--Presentacin y escritura de rtulos--}
{---------------------------------------}
procedure EscribeTexto(posx,posy,tamno:integer;texto:string);
{Escribe un texto en una posicin y con un tamao de letra que se le pasa}
   begin
        SetColor(LightGray);
        SetTextStyle(TriplexFont,Horizdir,tamno);
        OutTextXY(posx,posy,texto);
   end;

procedure RotuloXONIX;
   begin
        EscribeTexto(290,2,3,'XONIX');
   end;

procedure RotuloVidas(vidas:byte);
{Escribe en la pantalla un rtulo indicando las vidas que quedan, pero
  previamente pasa la variable vidas, que es un byte, a texto que se
  pueda escribir}
   var VidasTxt : string[2];
   begin
        Str(Vidas,VidasTxt);
        SetFillStyle(SolidFill,LightBlue);
        Bar(20,440,150,470);
        EscribeTexto(40,445,2,'Vidas : '+VidasTxt);
   end;

procedure RotuloPuntos(puntos:integer);
{Escribe en la pantalla un rtulo indicando los puntos conseguidos, y
  antes pasa la variable puntos, entero, a cadena de texto}
  var PuntosTxt : string[6];
   begin
        Str(Puntos,PuntosTxt);
        SetFillStyle(SolidFill,LightBlue);
        Bar(151,440,349,470);
        EscribeTexto(180,445,2,'Puntos : '+PuntosTxt);
   end;

procedure RotuloNivel(nivel:byte);
{Escribe en la pantalla un rtulo que indica el nivel actual, pasando
  previamente la variable nivel a texto}
   var NivelTxt : string[2];
   begin
        Str(Nivel,NivelTxt);
        SetFillStyle(SolidFill,LightBlue);
        Bar(350,440,479,470);
        EscribeTexto(360,445,2,'Nivel : '+NivelTxt);
   end;

procedure RotuloArea(area:integer);
{Escribe el area conquistada en la pantalla, pas ndola antes a cadena}
   var AreaTxt : string[3];
   begin
        Str(Area,AreaTxt);
        SetFillStyle(SolidFill,LightBlue);
        SetColor(Red);
        Bar(480,440,619,470);
        EscribeTexto(480,445,2,'Area : '+AreaTxt+'%');
   end;

procedure AvisoVidas(vidas:byte);
{Inserta un aviso en la pantalla cada vez que el jugador pierde una vida,
  comunicandole el nmero de vidas que le quedan. Una vez m s, es necesario
  pasar la variable de tipo byte a cadena de texto}
   var VidasTxt : string[2];
   begin
        Str(vidas,VidasTxt);
        SetFillStyle(SolidFill,LightBlue);
        Bar(150,230,500,305);
        if vidas = 0 then
           EscribeTexto(200,235,2,'Se te acabaron las vidas');
        if vidas = 1 then
           EscribeTexto(165,235,2,'Cuidado. Esta es tu ultima vida');
        if vidas > 1 then
           EscribeTexto(220,235,2,'Te quedan '+VidasTxt+' vidas.');
        EscribeTexto(190,270,1,'Pulsa espacio para continuar');
    end;

procedure AvisoNivel(nivel:byte);
{Inserta un aviso en la pantalla cada vez que el jugador completa un nivel,
  comunicandole el nivel completado. Se pasa la variable nivel a cadena que
  poder escribir en pantalla}
   var NivelTxt : string[1];
   begin
        Str(nivel,NivelTxt);
        SetFillStyle(SolidFill,LightBlue);
        Bar(150,230,500,305);
        EscribeTexto(230,235,2,'Nivel '+NivelTxt+' completado');
        EscribeTexto(190,270,1,'Pulsa espacio para continuar');
   end;

{---------------------------}
{--Procedures de los malos--}
{---------------------------}
procedure Malo.Fijar(posx,posy:byte;incrx,incry:shortint;prohi:boolean);
{Se le pasa una posicin, una direccin y el tipo de casilla por donde
  no le est  permitido moverse}
   begin
        X := posx;
        Y := posy;
        incx :=  incrx;
        incy :=  incry;
        Prohibida := prohi;
   end;

procedure Malo.Mover;
{Mueve los malos. El movimiento se realiza en un plano, por lo que se deben
  manejar las direcciones horizontal y vertical independientemente. Se sigue
  la direccin que llevaba hasta que se salga del tablero o encuentre un
  obst culo y rebote contra l.}
     procedure IncrementaX;
        begin
             if (x + incx = 0) or (x + incx > tableroX) then
                incX := -incX;
             if tablero[x+incx,y].estado = Prohibida then
                incX := -incx;
             x := x + incx;
        end;
     procedure IncrementaY;
        begin
             if (y + incy = 0) or (y + incy > tableroY) then
                incy := -incy;
             if tablero[x,y+incy].estado = Prohibida then
                incy := -incy;
             y := y + incy;
        end;
   begin
        IncrementaX; IncrementaY;
   end;

{-------------------------------------------------}
{--Procedures que dibujan en la pantalla gr fica--}
{-------------------------------------------------}
const ColorVacio   = DarkGray;  { Constantes de colores     }
      ColorOcupado = Cyan;      {para futuras modificaciones}
      ColorPeligro = LightGreen;
      ColorBueno   = White;
      ColorMalo    = Yellow;
      ColorTraidor = LightRed;

procedure PintaCuadrado(x,y,color:byte);
{Dibuja una casilla rellena en la pantalla, teniendo en cuenta que cada
  casilla del tablero equivale a FactorEscala*FactorEscala pixels. Tambin
  sita el tablero centrado en la pantalla, dejando 20 pixels a derecha e
  izquierda, y 40 encima y debajo.}
   var PixelX, PixelY : integer;
   begin
        SetFillStyle(SolidFill,color);
        PixelX:=((x-1)*FactorEscala)+20;
        PixelY:=((y-1)*FactorEscala)+40;
        Bar(PixelX,PixelY,PixelX+FactorEscala-1,PixelY+FactorEscala-1);
   end;

procedure PintaCirculo(x,y,color,colorfondo:byte);
{Dibuja una casilla con un malo, un traidor o el bueno en la pantalla,
  de modo que sean circulares. El efecto circular se consigue quitando
  las esquinas al cuadrado. Asume el centrado del tablero en la pantalla,
  as como el cambio de escala.}
   var PixelX, PixelY : integer;
   begin
        SetFillStyle(SolidFill,color);
        PixelX:=((x-1)*FactorEscala)+20;
        PixelY:=((y-1)*FactorEscala)+40;
        Bar(PixelX,PixelY,PixelX+FactorEscala-1,PixelY+FactorEscala-1);
        Putpixel(PixelX,PixelY,colorfondo);
        Putpixel(PixelX+FactorEscala-1,PixelY,colorfondo);
        Putpixel(PixelX,PixelY+FactorEscala-1,colorfondo);
        Putpixel(PixelX+FactorEscala-1,PixelY+FactorEscala-1,colorfondo);
   end;

procedure Rellenar;
{Va mirando cada casilla del tablero y las pinta del color que corresponda
  a su estado. Adem s, si la casilla est  vacia, la pone como
  "potencialmente rellenable" }
   var i, j : byte;
   begin
        for i := 1 to TableroX do begin
            for j := 1 to TableroY do begin
                if tablero[i,j].estado = vacia then begin
                   tablero[i,j].rellenar := true ;
                   PintaCuadrado(i,j,ColorVacio); end;
                if tablero[i,j].estado = llena then
                   PintaCuadrado(i,j,ColorOcupado);
            end;
       end;
   end;

procedure PintarBueno(dirx,diry:shortint);
{Este procedure tiene dos partes, dependiendo de por dnde se mueva el
  bueno. Si ste llega a una zona no rellena, empieza a hacer un area,
  pinta la casilla donde se encuentra del color asignado a las casillas
  en peligro, se mueve a donde le indiquen dirx y diry y all se pinta.
  Si se mueve por una zona ya rellena, la pinta del color que le corres-
  ponde, se mueve a donde le indiquen dirx y diry, y all se pinta}
   begin
        if tablero[PosBuenoX,PosBuenoY].estado=vacia then begin
           PintaCuadrado(PosBuenoX,PosBuenoY,ColorPeligro);
           PosBuenoX := PosBuenoX+dirx;
           PosBuenoY := PosBuenoY+diry;
           PintaCirculo(PosBuenoX,PosBuenoY,ColorBueno,ColorVacio); end
        else begin
           PintaCuadrado(PosBuenoX,PosBuenoY,ColorOcupado);
           PosBuenoX := PosBuenoX+dirx;
           PosBuenoY := PosBuenoY+diry;
           PintaCirculo(PosBuenoX,PosBuenoY,ColorBueno,ColorOcupado); end;
   end;

procedure PintarMalo;
{Este procedure es m s simple. Pinta a los malos que debe haber en el nivel
 de manera que deje la casilla de donde viene en color de vacia y se pinta
 en aquella que corresponde a su nueva posicin}
   var NumMalo : byte;
   begin
        for NumMalo := 1 to nivel do begin
        PintaCuadrado(malos[NumMalo].x-malos[NumMalo].incx,
                      malos[NumMalo].y-malos[NumMalo].incy,ColorVacio);
        PintaCirculo(malos[NumMalo].x,malos[NumMalo].y,ColorMalo,ColorVacio)
        end
   end;

procedure PintarTraidor;
{Pinta la casilla donde estaba de color ocupado y la nueva del color del
  traidor}
   var NumTraidor : byte;
   begin
        for NumTraidor := 1 to NumTraidores do begin
         PintaCuadrado(traidores[NumTraidor].x-traidores[NumTraidor].incx,
                       traidores[NumTraidor].y-traidores[NumTraidor].incy,
                       ColorOcupado);
         PintaCirculo(traidores[NumTraidor].x,
                       traidores[NumTraidor].y,ColorTraidor,ColorOcupado)
        end
   end;

procedure LimpiarTablero;
{Elimina las casillas que formaban los lmites de un area que ha sido cor-
  tada por un enemigo, pint ndolas de color vacio y quit ndoles el peligro}
   var i, j : byte;
   begin
        for i := 1 to TableroX do
            for j := 1 to TableroY do
                if tablero[i,j].peligro=true then begin
                   PintaCuadrado(i,j,ColorVacio);
                   tablero[i,j].peligro:=false end
   end;

Procedure HacerArea(x,y:integer);
{Procedure que marca las casillas que se van a rellenar cuando se cierra un
  area. Se le pasa la posicin de los malos y marca primero una linea hori-
  zontal a partir de la posicin del malo hasta que se encuentra una casilla
  que no debe rellenar. Cada casilla de esa linea (empezando por la situada
  m s a la izquierda) llama a su vez a las de encima y debajo, que vuelven a
  marcar la linea horizontal.}
   var tempx, tempy, marcadas, i : byte;
   begin
        tempx := x;
        tempy := y;
        marcadas := 0;
        repeat
              tablero[tempx,tempy].rellenar := False;
              marcadas := marcadas + 1;
              tempx := tempx + 1;
        until ((tablero[tempx,tempy].rellenar = False) or
               (tablero[tempx,tempy].estado = llena) or
               (tablero[tempx,tempy].peligro = true));
        tempx := x - 1;
        while ((tablero[tempx,tempy].rellenar = True) and
               (tablero[tempx,tempy].estado = vacia) and
               (tablero[tempx,tempy].peligro = False)) do
               begin
                    tablero[tempx,tempy].rellenar := False;
                    marcadas := marcadas + 1;
                    tempx := tempx - 1;
               end;
        tempx := tempx + 1;
        for i := tempx to tempx + marcadas do begin
            if ((tablero[i,tempy-1].rellenar = true) and
                (tablero[i,tempy-1].estado = vacia) and
                (tablero[i,tempy-1].peligro = false))
            then HacerArea(i,tempy-1);
            if ((tablero[i,tempy+1].rellenar = true) and
                (tablero[i,tempy+1].estado = vacia) and
                (tablero[i,tempy+1].peligro = false))
            then HacerArea(i,tempy+1);
         end;
   end;

Procedure Rellenado;
{Rellena las casillas marcadas con HacerArea, tanto en la matriz como
  en la pantalla}
   var i, j : integer;
   begin
        for i := 1 to TableroX do
            for j := 1 to TableroY do begin
                if tablero[i,j].peligro = true then begin
                   PintaCuadrado(i,j,ColorOcupado);
                   tablero[i,j].estado := llena;
                   tablero[i,j].peligro := false;
                   tablero[i,j].rellenar := true; end;
                if (tablero[i,j].estado = vacia) and
                   (tablero[i,j].rellenar = true) then begin
                   PintaCuadrado(i,j,ColorOcupado);
                   tablero[i,j].estado := llena; end;
                if (tablero[i,j].estado = vacia) and
                   (tablero[i,j].rellenar = false)then
                   tablero[i,j].rellenar := true;
            end
   end;
END.
