{---------------------------------------------------------------------}
{--------------------------------XONIX--------------------------------}
{---------------------------------------------------------------------}
{----Primera pr ctica de la asignatura Laboratorio de Programacin----}
{----de la ETSIT-UPM, curso 97/98. -----------------------------------}
{------------------------------------------Beatriz Jimnez------------}
{------------------------------------------Madrid, Febrero-Marzo '98--}
{---------------------------------------------------------------------}
program XONIX;
uses crt,                     {Unit de Borland, de la que se utilizan }
                              {funciones como delay, keypressed, sound}
                              {y los colores para el texto            }
     graficos;                {Unit creada para la pr ctica. Asume las}
                              {funciones de trabajo con la pantalla en}
                              {modo gr fico                           }

var Vidas, VidaExtra : byte;
    Area, Puntos, PuntosAcumulados : integer;
    PulsaEsc, EnPeligro, Muerto, Conseguido, Salir : boolean;

{------------------------}
{--Funciones auxiliares--}
{------------------------}
procedure Escribetexto(x,y,color:byte;texto:string);
{Para hacerlo m s inmediato y reducir los procedures que escriben
  mensajes en la pantalla}
   begin
        Gotoxy(x,y);
        TextColor(color);
        Write(texto)
   end;

procedure Pausa;
{Realiza una pausa cuya duracin la decide el usuario, y absorbe
  la tecla pulsada }
   var tecla : char;
   begin
        repeat until Keypressed;
        tecla := readkey;
   end;

Procedure PulsaEsp;
{Realiza una pausa hasta que el usuario pulse la barra espaciadora}
   begin
        repeat until ReadKey = ' ';
   end;

function tecla : char;
{Permite que el movimiento de los enemigos sea independiente de la pulsa-
  cion de las flechas, vaciando el buffer de teclado para que no haya acu-
  mulacin de teclas y no se siga moviendo cuando se dejen de pulsar}
   var teclach : char;
   begin
     if keypressed then teclach := readkey
        else teclach := #255;
     if teclach<>#0 then
        while keypressed do tecla := readkey;
     tecla:=teclach;
   end;

{-------------------------}
{--Presentacin y salida--}
{-------------------------}
procedure Presentacion;
{Da la bienvenida y pide el nivel de inicio hasta que sea correcto. Luego
  asigna el valor del caracter en nmero a una variable numrica, nivel}
   var nivelch : char;
   begin
        Escribetexto(10,5,Green,'Bienvenido a Xonix, Alvaro');
        repeat
          Escribetexto(10,7,Green,'Elije un nivel de juego (1..5): ');
          nivelch:=readkey;
          nivel:= ord(nivelch)-48;
        until (nivel>0) and (nivel<6);
          Escribetexto(10,20,Red,' ');
   end;

{-----------}
{--SONIDOS--}
{-----------}
procedure SonidoInicio;
{Sonido no muy largo ni muy llamativo, pero que obliga al jugador a
  reaccionar ante un nuevo nivel.}
   begin
        Sound(200); Delay(120);
        Sound(250); Delay(120);
        Sound(300); Delay(120);
        Sound(400); Delay(240);
        Sound(330); Delay(120);
        Sound(400); Delay(400);
        NoSound;
   end;

procedure SonidoMuerte;
{Sonido menos necesario, pero simp tico}
   begin
        Sound(350); Delay(350);
        Sound(325); Delay(350);
        Sound(315); Delay(350);
        Sound(300); Delay(700);
        NoSound;
   end;

{---------------------------------------}
{--Inicializacin del tablero de juego--}
{---------------------------------------}
Procedure InicializaVariables;
{Pone todas las variables a sus valores de inicio de partida}
   begin
         vidas:=3;
         Puntos:=0;
         PuntosAcumulados:=0;
         Muerto:=False;
         Conseguido:=False;
         Salir:=False;
   end;

procedure VaciaTablero;
{Inicializa el tablero, poniendo todas las casillas a vacia, sin estar a
  medio camino de cerrar un area y "potencialmente rellenables"}
   var i, j : byte;
   begin
        for i := 1 to TableroX do begin
            for j := 1 to TableroY do begin
                tablero[i,j].estado := vacia;
                tablero[i,j].peligro := false;
                tablero[i,j].rellenar := true;
            end;
        end;
   end;

procedure PonerBordes;
{Los bordes son de dos casillas, que se ponen a llena en la matriz del
  tablero. Luego se dibuja la pantalla con la llamada a Rellenar.}
   var i,j:byte;
   begin
        for j:=1 to TableroY do begin
            tablero[1,j].estado := llena;
            tablero[TableroX,j].estado := llena;
            tablero[2,j].estado := llena;
            tablero[TableroX-1,j].estado := llena;
        end;
        for i:=1 to TableroX do begin
            tablero[i,1].estado := llena;
            tablero[i,TableroY].estado := llena;
            tablero[i,2].estado := llena;
            tablero[i,TableroY-1].estado := llena;
        end;
        Rellenar;
   end;

{--------------------------------}
{--Calculo de valores del juego--}
{--------------------------------}
procedure Porcentaje;
{Calcula el porcentaje de area conquistada cada vez que se cierra un area,
  sin tener en cuenta los bordes. El porcentaje se calcula dividiendo el
  nmero de casillas llenas entre el nmero de casillas totales y por 100,
  pero se simplifican los c lculos usando directamente el resultado de
  dividir el nmero de casillas totales entre 100}
    var i, j :byte;
        porcent : integer;
    begin
         area := 0;
         for i := AnchoBordes+1 to TableroX-AnchoBordes do begin
             for j := AnchoBordes+1 to TableroY-AnchoBordes do
                 if tablero[i,j].estado= llena then area := area +1;
             end;
         area := area div 140;
         RotuloArea(area);
    end;

Procedure Puntuacion;
{Calcula la puntuacion actual bas ndose en el area conquistada y en los
  puntos acumulados hasta el nivel anterior. Tiene un "extra": si se al-
  canzan las puntuaciones de 500, 1000, 1500 y 2000 puntos se suma una
  vida.}
   begin
        Puntos := PuntosAcumulados + ( area * nivel );
        RotuloPuntos(puntos);
        case ( Puntos div 500 ) of
             1 : if vidaextra = 0 then begin
                    Vidas := Vidas + 1;
                    RotuloVidas(Vidas);
                    vidaextra := 1;    end;
             2 : if vidaextra = 1 then begin
                    Vidas := Vidas + 1;
                    RotuloVidas(Vidas);
                    vidaextra := 2;    end;
             3 : if vidaextra = 2 then begin
                    Vidas := Vidas + 1;
                    RotuloVidas(Vidas);
                    vidaextra := 3;    end;
             4 : if vidaextra = 3 then begin
                    Vidas := Vidas + 1;
                    RotuloVidas(Vidas);
                    vidaextra := 4;    end;
        end;
   end;

{----------------------------}
{--Movimientos de los malos--}
{----------------------------}
procedure FijarTraidores;
{Los traidores parten de los puntos medios de los bordes laterales, y su
  posicin inicial no es aleatoria para que no puedan quedar muy cerca
  del bueno y matarlo antes de que sea imposible moverlo}
   begin
        traidores[1].fijar(AnchoBordes,TableroY div 2,1,-1,vacia);
        traidores[2].fijar(TableroX-(AnchoBordes-1),TableroY div
2,-1,1,vacia);
        PintarTraidor;
   end;

procedure MoverTraidores;
{Mueve los traidores y despus los pinta en su nueva posicin}
   begin
        traidores[1].mover;
        traidores[2].mover;
        PintarTraidor;
   end;

procedure FijarMalos;
{Los malos parten de un lugar aleatorio y con una direccin tambin
  aleatoria, pero evitando los bordes}
   var NumMalo : byte;
       inc: integer;
   begin
        randomize;
        for NumMalo := 1 to nivel do
           with malos[NumMalo] do begin
                x:=random(TableroX-(2*AnchoBordes+1))+2*AnchoBordes;
                y:=random(TableroY-(2*AnchoBordes+1))+2*AnchoBordes;
                inc:=random(2); if inc=0 then incx:=1 else incx:=-1;
                inc:=random(2); if inc=0 then incy:=1 else incy:=-1;
                fijar(x,y,incx,incy,llena);
           end;
        PintarMalo;
   end;

procedure MoverMalos;
{Mueve los malos y luego los pinta}
   var NumMalo : byte;
   begin
        for NumMalo:= 1 to nivel do
            malos[NumMalo].mover;
        PintarMalo;
   end;

{---------------------------}
{--Movimientos del jugador--}
{---------------------------}
procedure ComprobarHacerArea;
{Comprueba si se ha iniciado la construccin de un area. En caso afirmativo,
  marca el estado peligro de la casilla como true para posibles choques,
  pone a True la variable EnPeligro, que permite saber si se est  haciendo
  un area que todava no se ha cerrado, y comienza a emitir un sonido}
    begin
         if tablero[posBuenox,posBuenoy].estado=vacia then
              begin
                tablero[posBuenox,posBuenoy].peligro:=true;
                EnPeligro := True;
                Sound(100);
              end;
    end;

procedure ComprobarChoques;
{Comprueba el choque de los malos tanto con el bueno como con los lmites
  del area que estuviera construyendo (casillas cuyo campo "peligro" era
  True), y en caso afirmativo pone EnPeligro a False, muerto a true y
  cesa de emitir el sonido de creacin de area.}
{En el caso de los traidores, solo es necesario que coincida la posicin}
   var NumMalo : byte;
   begin
        for NumMalo := 1 to nivel do begin
           if (tablero[malos[NumMalo].x,malos[NumMalo].y].peligro=true) or
              ((Malos[NumMalo].x=posBuenox) and
(Malos[NumMalo].y=posBuenoy))
              then begin
                        EnPeligro:=False;
                        muerto:=true;
                        Nosound  end;
            end;
        for NumMalo := 1 to NumTraidores do
            if (traidores[NumMalo].x=posBuenox) and
               (traidores[NumMalo].y=posBuenoy)
               then muerto:=true
   end;

procedure ComprobarCierreArea;
{Comprueba si se ha cerrado un area que se vena construyendo, ya que de ser
  as la posicin del bueno debe ser una casilla llena y la anterior una
  vacia (EnPeligro=True). En caso afirmativo se deja de emitir el sonido,
  se rellena el area cerrada y se calculan los nuevos valores del juego}
   var NumMalo : byte;
   begin
        if (tablero[posBuenox,posBuenoy].estado=llena) and
           (EnPeligro=True) then
               begin
                    Nosound;
                    for NumMalo := 1 to nivel do
                        HacerArea(malos[NumMalo].x,
                                        malos[NumMalo].y);
                    Rellenado;
                    Porcentaje;
                    Puntuacion;
                    EnPeligro:=False;
                    if area > 74 then conseguido:=true;
                end;
   end;

procedure FijarBueno;
{El bueno siempre parte de arriba en el medio, y no viene de una casilla
  anterior, por eso se le pinta con direccin 0,0}
   begin
       PosBuenoX:=TableroX div 2;
       PosBuenoY:=2;
       PintarBueno(0,0);
   end;

procedure MoverBueno;
{Este procedure maneja los movimientos del jugador (el "bueno"), as como
  abandonar el juego o la pausa. Permite que el movimiento de los malos y
  los traidores sea independiente de la velocidad del equipo, y sta de-
  pende del nivel en que se encuentre el jugador. Impide que el bueno se
  vuelva sobre si mismo o se salga del tablero}
   begin
         delay(70-(10*nivel));
         pulsaEsc := False;
         case tecla of
           #27 : pulsaEsc := True;
           'P','p' : pausa;
           #0  : case tecla of
              #72: begin
                     if posBuenoy=1 then posBuenoy:=1
                        else if tablero[posBuenox,posBuenoy-1].peligro=true
                             then begin
                                  EnPeligro:=False;
                                  muerto:= true;
                                  end
                                  else PintarBueno(0,-1)
                   end;
              #75: begin
                     if posBuenox=1 then posBuenox:=1
                        else if tablero[posBuenox-1,posBuenoy].peligro=true
                             then begin
                                  EnPeligro:=False;
                                  muerto:=true;
                                  end
                             else PintarBueno(-1,0)
                   end;
              #77: begin
                     if posBuenox=TableroX then posBuenox:=TableroX
                        else if tablero[posBuenox+1,posBuenoy].peligro=true
                             then begin
                                  EnPeligro:=False;
                                  muerto:=true;
                                  end
                             else PintarBueno(1,0)
                   end;
              #80: begin
                     if posBuenoy=TableroY then posBuenoy:=TableroY
                        else if tablero[posBuenox,posBuenoy+1].peligro=true
                             then begin
                                  EnPeligro:=False;
                                  muerto:=true;
                                  end
                             else PintarBueno(0,1)
                   end
               end
           end;
   end;

{----------}
{--Muerte--}
{----------}
procedure Muerte;
{Se le llama cuando la variable muerto=True, en cualquiera de los supuestos
  (choque con malo, traidor o consigo mismo). Disminuye las vidas y depen-
  diendo de las que queden, si es 0 sale del juego o si es otro nmero
  pone el bueno en su posicin inicial, limpia el tablero de casillas que
  estuvieran en peligro (a medio camino de cerrar un area), y deja que malos
  y traidores sigan moviendose por donde lo hacan}
   begin
        vidas := vidas - 1;
        Nosound;
        if vidas = 0 then begin
           AvisoVidas(0);
           PulsaEsp;
           Modotexto;
           Clrscr;
           Escribetexto(35,12,Magenta+Blink,'GAME OVER');
           Escribetexto(79,25,White,' ');
           SonidoMuerte;
           Pausa;
           Clrscr;
           Salir:=True;
           end
        else begin
           muerto:=False;
           limpiartablero;
           AvisoVidas(vidas);
           PulsaEsp;
           Rellenar;
           FijarBueno;
           RotuloVidas(vidas);
           end;
   end;

{---------}
{--Exito--}
{---------}
procedure Exito;
{Se le llama cuando conseguido=true, es decir, cuando se ha completado el
  75% de area de un nivel. Si el nivel completado es el 5, sale del progra-
  ma, si es otro, comienza un nivel superior con el tablero en blanco y
  nuevas posiciones de malos, traidores y bueno.}
   begin
        if nivel=5 then begin
           AvisoNivel(nivel);
           PulsaEsp;
           Modotexto;
           Clrscr;
           Escribetexto(29,12,Magenta+Blink,'FELICIDADES!!!!');
           Escribetexto(15,20,DarkGray,'Pero no le digas a nadie que lo has conseguido ;-)');
           Escribetexto(79,25,White,' ');
           Pausa;
           Clrscr;
           Salir:=True;
           end
        else begin
           AvisoNivel(nivel);
           PulsaEsp;
           nivel:=nivel+1;
           vaciatablero;
           PonerBordes;
           FijarBueno;
           FijarMalos;
           FijarTraidores;
           area:=0;
           RotuloArea(area);
           RotuloNivel(nivel);
           PuntosAcumulados:=Puntos;
           Conseguido:=False;
           SonidoInicio;
        end
   end;

{--------------------------}
{--Comprobacin de salida--}
{--------------------------}
function QuiereSalir:boolean;
{Informa de los resultados obtenidos en la ltima partida y pregunta si
  se desea jugar otra vez.}
   var quiere : char;
       puntostxt : string[5];
   begin
        Modotexto;
        QuiereSalir:=False;
        str(puntos,puntostxt);
        Escribetexto(36,3,LightBlue+Blink,'XONIX');
        Escribetexto(33,8,LightCyan,'Resultados');
        Escribetexto(33,9,LightCyan,'----------');
        Escribetexto(33,11,Cyan,'Nivel  : '+chr(48+nivel));
        Escribetexto(33,13,Cyan,'Puntos : '+puntostxt);
        Escribetexto(33,15,Cyan,'Vidas  : '+chr(48+vidas));
        repeat
              Escribetexto(40,20,LightBlue,'Quieres intentarlo otra vez? (S/N) ');
              quiere := upcase (readkey);
        until (quiere = 'S') or (quiere = 'N');
        case quiere of
             'S' : QuiereSalir:=False;
             'N' : begin
                        Escribetexto(2,23,White,'Hasta la prxima...');
                        QuiereSalir:=True;
                   end
        end
   end;

{------------}
{--El juego--}
{------------}
procedure Jugar;
{Procedure que controla el juego en s. El bucle se repite hasta que se ha
  pulsado la tecla escape, pero tambin se sale en caso de muerte o exito.}
   begin
        repeat
              MoverBueno;
              MoverMalos;
              MoverTraidores;
              ComprobarHacerArea;
              ComprobarChoques;
              ComprobarCierreArea;
              if muerto then muerte;
              if conseguido then exito;
              if salir then exit;
        until PulsaEsc;
   end;

BEGIN
{El bucle principal es una partida nueva, por lo tanto se repite mientras
  el jugador acabe una y quiera jugar otra. Se inicia en modo texto, se
  pide el nivel de inicio y se ponen las variables a su valor inicial en
  memoria y en pantalla. Se sitan malos, traidores y bueno, y se juega.}
   repeat
         Clrscr;
         presentacion;
         ModoGrafico;
         InicializaVariables;
         VaciaTablero;
         RotuloXONIX;
         RotuloVidas(vidas);
         RotuloPuntos(puntos);
         RotuloNivel(nivel);
         RotuloArea(area);
         PonerBordes;
         FijarBueno;
         FijarMalos;
         FijarTraidores;
         SonidoInicio;
         Jugar
   until QuiereSalir;
END.
